<?php
class Application_Model_LeadHelper {
	var $db;
    public function __construct() {
        $this->db = Zend_Registry::get('DATABASE_SCHEMA');
    }
	
	/*** LEAD SOURCES ***/
	public function getLeadSources() {
		$sql = "SELECT * FROM `lead_sources` ORDER BY `source_title`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getLeadSourceByID($sourceID) {
		$sql = "SELECT * FROM `lead_sources` WHERE `source_id`=".$sourceID;
		return $this->db->query($sql)->fetch();
	}
	
	public function changeLeadSourceStatus($sourceID) {
		$leadStatus = $this->getLeadSourceByID($sourceID);
		$newStatus = 1;
		if($leadStatus['source_status']==1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `lead_sources` SET `source_status`=".$newStatus." WHERE `source_id`=".$sourceID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Lead Source status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Lead Source status cannot be changed. Please try again later.');
		}
	}
	
	private function checkIfLeadSourceExists($data) {
		if($data['id'] == 0) { //New Source
			$sql = "SELECT * FROM `lead_sources` WHERE `source_title`='".$data['title']."'";
		} else { //Existing Source
			$sql = "SELECT * FROM `lead_sources` WHERE `source_title`='".$data['title']."' AND `source_id`!=".$data['id'];
		}
		$rs = $this->db->query($sql)->fetchAll();
		if(count($rs)>0) {
			return true;
		} else {
			return false;
		}
	}
	
	public function saveLeadSource($data) {
		if($this->checkIfLeadSourceExists($data)) {
			return array('code'=>-1, 'msg'=>'This Lead Source already exists. Please try another.');
		} else {
			if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `lead_sources`(`source_title`) VALUES ('".$data['title']."')";
			} else { //UPDATE
				$sql = "UPDATE `lead_sources` SET `source_title`='".$data['title']."' WHERE `source_id`=".$data['id'];
			}
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'Lead Source saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'Lead Source cannot be saved. Please try again later.');
			}
		}		
	}
	/*** LEAD SOURCES ***/
	
	/*** LEAD STATUS ***/
	public function getLeadStatuses() {
		$sql = "SELECT * FROM `lead_status`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getLeadStatusByID($statusID) {
		$sql = "SELECT * FROM `lead_status` WHERE `status_id`".$statusID;
		return $this->db->query($sql)->fetchAll();
	}
	
	private function checkIfLeadStatusExists($data) {
		if($data['id'] == 0) { //New Status
			$sql = "SELECT * FROM `lead_status` WHERE `status_title`='".$data['title']."'";
		} else { //Existing Source
			$sql = "SELECT * FROM `lead_status` WHERE `status_title`='".$data['title']."' AND `status_id`!=".$data['id'];
		}
		$rs = $this->db->query($sql)->fetchAll();
		if(count($rs)>0) {
			return true;
		} else {
			return false;
		}
	}
	
	public function saveLeadStatus($data) {
		if($this->checkIfLeadStatusExists($data)) {
			return array('code'=>-1, 'msg'=>'This Lead Status already exists. Please try another.');
		} else {
			if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `lead_status`(`status_title`, `status_color`) VALUES ('".$data['title']."', '".$data['color']."')";
			} else { //UPDATE
				$sql = "UPDATE `lead_status` SET `status_title`='".$data['title']."', `status_color`='".$data['color']."' WHERE `status_id`=".$data['id'];
			}
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'Lead Status saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'Lead Status cannot be saved. Please try again later.');
			}
		}		
	}
	/*** LEAD STATUS ***/
	
	/*** LEAD DISPOSITION ***/
	public function getLeadDispositions() {
		$sql = "SELECT * FROM `lead_disposition`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getLeadDispositionByID($disID) {
		$sql = "SELECT * FROM `lead_disposition` WHERE `dis_id`=".$disID;
		return $this->db->query($sql)->fetch();
	}
	
	public function changeLeadDispositionStatus($disID) {
		$leadDisposition = $this->getLeadDispositionByID($disID);
		$newStatus = 1;
		if($leadStatus['dis_status']==1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `lead_disposition` SET `dis_status`=".$newStatus." WHERE `dis_id`=".$sourceID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Lead Disposition status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Lead Disposition status cannot be changed. Please try again later.');
		}
	}
	
	private function checkIfLeadDispositionExists($data) {
		if($data['id'] == 0) { //New Disposition
			$sql = "SELECT * FROM `lead_disposition` WHERE `dis_title`='".$data['title']."'";
		} else { //Existing Disposition
			$sql = "SELECT * FROM `lead_disposition` WHERE `dis_title`='".$data['title']."' AND `dis_id`!=".$data['id'];
		}
		$rs = $this->db->query($sql)->fetchAll();
		if(count($rs)>0) {
			return true;
		} else {
			return false;
		}
	}
	
	public function saveLeadDisposition($data) {
		if($this->checkIfLeadDispositionExists($data)) {
			return array('code'=>-1, 'msg'=>'This Lead Disposition already exists. Please try another.');
		} else {
			if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `lead_disposition`(`dis_title`) VALUES ('".$data['title']."')";
			} else { //UPDATE
				$sql = "UPDATE `lead_disposition` SET `dis_title`='".$data['title']."' WHERE `dis_id`=".$data['id'];
			}
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'Lead Disposition saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'Lead Disposition cannot be saved. Please try again later.');
			}
		}		
	}
	/*** LEAD DISPOSITION ***/
	
	/*** LEADS ***/
	public function getLeads($q='',$lmt=0) {
		$cond = "";
		$limit = "";
		if(trim($q)!="") {
			$cond = " AND (`lead_full_name` LIKE '%".$q."%' OR `lead_phone` LIKE '%".$q."%' OR `lead_email` LIKE '%".$q."%' OR `lead_city` LIKE '%".$q."%' OR `lead_address` LIKE '%".$q."%' OR `lead_province` LIKE '%".$q."%' OR `lead_postal_code` LIKE '%".$q."%')";
		}
		if($lmt != 0) {
			$limit = " LIMIT 0, ".$lmt;
		}
		$sql = "SELECT `l`.`*`, `ls`.`status_title` FROM `leads` `l`, `lead_status` `ls` WHERE `ls`.`status_id`=`l`.`lead_status`".$cond.$limit;
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getLeadByID($leadID) {
		$arr = array();
		$sql = "SELECT `l`.`*`, `ls`.`status_title` FROM `leads` `l`, `lead_status` `ls` WHERE `ls`.`status_id`=`l`.`lead_status` AND `lead_id`=".$leadID;
		$rsLeadInfo = $this->db->query($sql)->fetch();
		
		$sql = "SELECT * FROM `lead_additional` WHERE `add_lead_id`=".$leadID;
		$rsLeadAdd = $this->db->query($sql)->fetch();
		
		$sql = "SELECT * FROM `lead_comments` WHERE `com_lead_id`=".$leadID;
		$rsLeadComments = $this->db->query($sql)->fetchAll();
		
		$sql = "SELECT * FROM `lead_pictures` WHERE `pic_lead_id`=".$leadID;
		$rsLeadPics = $this->db->query($sql)->fetchAll();
		
		$sql = "SELECT * FROM `proposals` WHERE `pro_lead_id`=".$leadID;
		$rsLeadProps = $this->db->query($sql)->fetchAll();
		
		$arr['info'] = $rsLeadInfo;
		$arr['additional'] = $rsLeadAdd;
		$arr['comments'] = $rsLeadComments;
		$arr['pictures'] = $rsLeadPics;
		$arr['proposals'] = $rsLeadProps;
		
		return $arr;
	}
	
	public function changeLeadStatus($leadID, $statusID) {
		$sql = "UPDATE `leads` SET `lead_status`=".$statusID." WHERE `lead_id`=".$leadID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Lead status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Lead status cannot be changed. Please try again later.');
		}
	}
	
	private function saveLeadAdditionalInfo($leadID, $notes) {
		$sql = "SELECT * FROM `lead_additional` WHERE `add_lead_id`=".$leadID;
		$rsAdd = $this->db->query($sql)->fetch();
		if($rsAdd) {
			$sql = "UPDATE `lead_additional` SET `add_notes`='".$notes."' WHERE `add_lead_id`=".$leadID;			
		} else {
			$sql = "INSERT INTO `lead_additional` (`add_lead_id`, `add_notes`) VALUES (".$leadID.", '".$notes."')";
		}
		$this->db->query($sql);
		$sql = "UPDATE `leads` SET `lead_update_date`='".date('Y-m-d H:i:s')."' WHERE `lead_id`=".$leadID;
		$this->db->query($sql);
	}
	
	public function saveLead($arr) {
		$dt = date('Y-m-d H:i:s');
		if($arr['id']==0) { //New Lead
			$sql = "INSERT INTO `leads` (`lead_create_date`, `lead_update_date`, `lead_source_id`, `lead_status`) VALUES ('".$dt."', '".$dt."', ".$arr['source'].", ".$arr['status'].")";
			$this->db->query($sql);
			$arr['id'] = $this->db->lastInsertID();
		}
		$sql = "UPDATE `leads` SET 
				`lead_full_name`='".$arr['fullName']."',
				`lead_phone`='".$arr['phone']."',
				`lead_email`='".$arr['email']."',
				`lead_address`='".$arr['address']."',
				`lead_city`='".$arr['city']."',
				`lead_province`='".$arr['province']."',
				`lead_postal_code`='".$arr['postal']."',
				`lead_lat`='".$arr['lat']."',
				`lead_lng`='".$arr['lng']."' 
				WHERE `lead_id`=".$leadID;
		if($this->db->query($sql)) {
			$this->saveLeadAdditionalInfo($arr['id'], $arr['notes']);
			return array('code'=>1, 'msg'=>'Lead saved successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Lead cannot be saved. Please try again later.');
		}
	}
	
	public function addLeadPicture($pics) {
		foreach($pics as $pic) {
			$sql = "INSERT INTO `lead_pictures` (`pic_title`, `pic_file_url`, `pic_lead_id`) VALUES ('".$pic['title']."', '".$pic['url']."', ".$pic['leadID'].")";
			$this->db->query($sql);
		}
		return array('code'=>1, 'msg'=>'Picture(s) saved successfully.');
	}
	
	public function removeLeadPicture($picID) {
		$sql = "DELETE FROM `lead_pictures` WHERE `pic_id`=".$picID;
		$this->db->query($sql);
		return array('code'=>1, 'msg'=>'Picture removed successfully.');
	}	
	/*** LEADS ***/
	
	/*** PROPOSALS ***/
	public function getProposals() {
		$sql = "SELECT * FROM `proposals` ORDER BY `pro_id` DESC";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getProposalByID($proID) {
		$sql = "SELECT * FROM `proposals` WHERE `pro_id`=".$proID;
		return $this->db->query($sql)->fetch();
	}
	
	public function addProposal($arr) {
		$sql = "INSERT INTO `proposals` (`pro_lead_id`, `pro_uploaded_by`, `pro_uploaded_at`, `pro_title`, `pro_file_url`) VALUES (".$arr['leadID'].", ".$arr['userID'].", '".date('Y-m-d H:i:s')."', '".$arr['title']."', '".$arr['url']."')";
		$this->db->query($sql);
		return array('code'=>1, 'msg'=>'Proposal added successfully.');
	}
	
	public function removeProposal($propID) {
		$sql = "DELETE FROM `proposals` WHERE `pro_id`=".$propID;
		$this->db->query($sql);
		return array('code'=>1, 'msg'=>'Proposal removed successfully.');
	}
	/*** PROPOSALS ***/
	
	/*** APPOINTMENT ***/
	public function setAppointment($data) {
		$sql = "SELECT * FROM `appointments` WHERE `app_lead_id`=".$data['leadID']." AND `app_disp_id`!=0";
		$rsLead = $this->db->query($sql)->fetch();
		if($rs) { //Appointment already set for this lead
			return array('code'=>0, 'msg'=>'An appointment is already scheduled for this lead.');
		} else {
			$sql = "INSERT INTO `appointments` (`app_lead_id`, `app_date`, `app_time_slot`, `app_user_id`, `app_notes`) VALUES (".$data['leadID'].", '".$data['date']."', ".$data['timeSlot'].", ".$data['userID'].", '".$data['notes']."')";
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'Appointment has been set successfully.');
			} else {
				return array('code'=>-1, 'msg'=>'Appointment cannot be set. Please try again later.');
			}
		}
	}
	
	public function setDisposition($data) {
		$disposition = $this->getLeadDispositionByID($data['dispID']);
		$sql = "UPDATE `appointments` SET `app_disp_id`=".$data['dispID']." WHERE `app_id`=".$data['appID'];
		$this->db->query($sql);
		
		$commentText = "Disposition changed to ".$disposition['dis_title'];
		$sql = "INSERT INTO `lead_comments` (`com_lead_id`, `com_text`, `com_date`, `com_ip`, `com_user_id`) VALUES (".$data['leadID'].", '".addslashes($commentText)."', '".$data['date']."', '".$data['ip']."', ".$data['userID'].")";
		$this->db->query($sql);
		
		if($data['notes']!='') {
			$sql = "INSERT INTO `lead_comments` (`com_lead_id`, `com_text`, `com_date`, `com_ip`, `com_user_id`) VALUES (".$data['leadID'].", '".$data['notes']."', '".$data['date']."', '".$data['ip']."', ".$data['userID'].")";
			$this->db->query($sql);
		}
	}
	/*** APPOINTMENT ***/
}