<?php
class Application_Model_SettingsHelper {
	var $db;
    public function __construct() {
        $this->db = Zend_Registry::get('DATABASE_SCHEMA');
    }
	
	/*** SETTINGS ***/
	public function getSettings() {
		$sql = "SELECT * FROM `settings` ORDER BY `set_caption`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getSettingsByField($field, $val) {
		$sql = "SELECT * FROM `settings` WHERE `".$field."`='".$val."'";
		return $this->db->query($sql)->fetch();
	}
	
	public function changeSettingsStatus($setID) {
		$settingsStatus = $this->getSettingsByField('set_id', $setID);
		$newStatus = 1;
		if($settingsStatus['set_status']==1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `settings` SET `set_status`=".$newStatus." WHERE `set_id`=".$setID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Settings status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Settings status cannot be changed. Please try again later.');
		}
	}
	
	private function checkIfSettingsExists($data) {
		if($data['id'] == 0) { //New Settings
			$sql = "SELECT * FROM `settings` WHERE `set_key`='".$data['key']."'";
		} else { //Existing Settings
			$sql = "SELECT * FROM `settings` WHERE `set_key`='".$data['key']."' AND `set_id`!=".$data['id'];
		}
		$rs = $this->db->query($sql)->fetchAll();
		if(count($rs)>0) {
			return true;
		} else {
			return false;
		}
	}
	
	public function saveSettings($data) {
		if($this->checkIfSettingsExists($data)) {
			return array('code'=>-1, 'msg'=>'This Settings already exists. Please try another.');
		} else {
			if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `settings`(`set_caption`, `set_key`, `set_val`) VALUES ('".$data['caption']."', '".$data['key']."', '".$data['val']."')";
			} else { //UPDATE
				$sql = "UPDATE `settings` SET `set_caption`='".$data['caption']."', `set_val`='".$data['val']."' WHERE `set_id`=".$data['id'];
			}
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'Settings saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'Settings cannot be saved. Please try again later.');
			}
		}		
	}
	/*** SETTINGS ***/
	
	/*** TIME SLOTS ***/
	public function getTimeSlots() {
		$sql = "SELECT * FROM `time_slots` ORDER BY `slot_start_time`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getTimeSlotByID($slotID) {
		$sql = "SELECT * FROM `time_slots` WHERE `slot_id`=".$slotID;
		return $this->db->query($sql)->fetch();
	}
	
	public function changeTimeSlotStatus($slotID) {
		$slot = $this->getTimeSlotByID($slotID);
		$newStatus = 1;
		if($slot['slot_status']==1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `time_slots` SET `slot_status`=".$newStatus." WHERE `slot_id`=".$slotID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Time Slot status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Time Slot status cannot be changed. Please try again later.');
		}
	}
	
	public function saveTimeSlot($data) {
		if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `time_slots`(`slot_start_time`, `slot_end_time`) VALUES ('".$data['start']."', '".$data['end']."')";
			} else { //UPDATE
				$sql = "UPDATE `time_slots` SET `slot_start_time`='".$data['start']."', `slot_end_time`='".$data['end']."' WHERE `slot_id`=".$data['id'];
			}
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'Time Slot saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'Time Slot cannot be saved. Please try again later.');
			}
	}
	/*** TIME SLOTS ***/
}