<?php
class Application_Model_UserHelper {
	var $db;
    public function __construct() {
        $this->db = Zend_Registry::get('DATABASE_SCHEMA');
    }
	/*** MISC ***/
	private function hashed($str) {
		return md5(strrev(strtoupper(trim($str))));
	}
	/*** MISC ***/
	
	/*** USER ROLES ***/
	public function getUserRoles() {
		$sql = "SELECT * FROM `user_roles`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getUserRoleByID($roleID) {
		$sql = "SELECT * FROM `user_roles` WHERE `role_id`=".$roleID;
		return $this->db->query($sql)->fetch();
	}
	
	public function changeUserRoleStatus($roleID) {
		$role = $this->getUserRoleByID($roleID);
		$newStatus = 1;
		if($role['role_status']==1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `user_roles` SET `role_status`=".$newStatus." WHERE `role_id`=".$roleID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'User Role status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'User Role status cannot be changed. Please try again later.');
		}
	}
	
	private function checkIfUserRoleExists($data) {
		if($data['id'] == 0) { //New Role
			$sql = "SELECT * FROM `user_roles` WHERE `role_title`='".$data['title']."'";
		} else { //Existing Role
			$sql = "SELECT * FROM `user_roles` WHERE `role_title`='".$data['title']."' AND `role_id`!=".$data['id'];
		}
		$rs = $this->db->query($sql)->fetchAll();
		if(count($rs)>0) {
			return true;
		} else {
			return false;
		}
	}
	
	public function saveUserRole($data) {
		if($this->checkIfUserRoleExists($data)) {
			return array('code'=>-1, 'msg'=>'This User Role already exists. Please try another.');
		} else {
			if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `user_roles`(`role_title`) VALUES ('".$data['title']."')";
			} else { //UPDATE
				$sql = "UPDATE `user_roles` SET `role_title`='".$data['title']."' WHERE `role_id`=".$data['id'];
			}
			if($this->db->query($sql)) {
				return array('code'=>1, 'msg'=>'User Role saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'User Role cannot be saved. Please try again later.');
			}
		}
	}
	/*** USER ROLES ***/
	
	/*** PERMISSIONS ***/
	public function getPermissions() {
		$sql = "SELECT * FROM `permissions`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getPermissionByID($permID) {
		$sql = "SELECT * FROM `permissions` WHERE `perm_id`=".$permID;
		return $this->db->query($sql)->fetch();
	}
	
	public function changePermissionStatus($permID) {
		$perm = $this->getPermissionByID($permID);
		$newStatus = 1;
		if($perm['perm_status']==1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `permissions` SET `perm_status`=".$newStatus." WHERE `perm_id`=".$permID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Permission status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Permission status cannot be changed. Please try again later.');
		}
	}
	
	public function savePermission($data) {		
		if($data['id']==0) { //INSERT
			$sql = "INSERT INTO `permissions`(`perm_title`) VALUES ('".$data['title']."')";
		} else { //UPDATE
			$sql = "UPDATE `permissions` SET `perm_title`='".$data['title']."' WHERE `perm_id`=".$data['id'];
		}
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'Permission saved successfully.');
		} else {
			return array('code'=>0, 'msg'=>'Permission cannot be saved. Please try again later.');
		}		
	}
	/*** PERMISSIONS ***/
	
	/*** USERS ***/
	public function getUsers() {
		$sql = "SELECT * FROM `users` ORDER BY `user_full_name`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getUserByID($userID) {
		$sql = "SELECT * FROM `users` WHERE `user_id`=".$userID;
		return $this->db->query($sql)->fetch();
	}
	
	public function changeUserStatus($userID) {
		$user = $this->getUserByID($userID);
		$newStatus = 1;
		if($user['user_status'] == 1) {
			$newStatus = 0;
		}
		$sql = "UPDATE `users` SET `user_status`=".$newStatus." WHERE `user_id`=".$userID;
		if($this->db->query($sql)) {
			return array('code'=>1, 'msg'=>'User status changed successfully.');
		} else {
			return array('code'=>0, 'msg'=>'User status cannot be changed. Please try again later.');
		}
	}
	
	private function checkIfUserExists($data) {
		if($data['id'] == 0) { //New User
			$sql = "SELECT * FROM `users` WHERE `user_name`='".$data['userName']."'";
		} else { //Existing User
			$sql = "SELECT * FROM `users` WHERE `user_name`='".$data['userName']."' AND `user_id`!=".$data['id'];
		}
		$rs = $this->db->query($sql)->fetchAll();
		if(count($rs)>0) {
			return true;
		} else {
			return false;
		}
	}
	
	private function setUserPermissionByRole($userID, $roleID) {
		$sql = "SELECT * FROM `role_permissions` WHERE `rp_role_id`=".$roleID;
		$rsRoles = $this->db->query($sql)->fetchAll();
		
		$strRoles = "";
		foreach($rsRoles as $role) {
			if($strRoles == "") {
				$strRoles = $role['rp_perm_id'];
			} else {
				$strRoles = ",".$role['rp_perm_id'];
			}
		}
		$sql = "SELECT * FROM `user_permissions` WHERE `p_user_id`=".$userID;
		$rsUser = $this->db->query($sql)->fetch();
		if(count($rsUser)==0) {
			$sql = "INSERT `user_permissions`(`p_user_id`, `p_perms`) VALUES (".$userID.", '".$strRoles."')";
		} else {
			$sql = "UPDATE `user_permissions` SET `p_perms`='".$strRoles."' WHERE `p_user_id`=".$userID;
		}
		$this->db->query($sql);
	}
	
	public function saveUser($data) {	
		if($this->checkIfUserExists($data)) {
			return array('code'=>-1, 'msg'=>'This User already exists. Please try another.');
		} else {
			if($data['id']==0) { //INSERT
				$sql = "INSERT INTO `users`(`user_name`, `user_pass`) VALUES ('".$data['userName']."', '".$this->hashed($data['password'])."')";
				$this->db->query($sql);
				$data['id'] = $this->db->lastInsertID();
			}
			$sql = "UPDATE `users` SET 
						`user_full_name`='".$data['fullName']."',
						`user_phone`='".$data['phone']."',
						`user_email`='".$data['email']."',
						`user_role_id`=".$data['roleID']." 
						WHERE `user_id`=".$data['id'];
			if($this->db->query($sql)) {
				$this->setUserPermissionByRole($data['id'], $data['roleID']);
				if($data['roleID']==99) { //Agent
					$this->saveAgentInfo($data);
				}
				return array('code'=>1, 'msg'=>'User saved successfully.');
			} else {
				return array('code'=>0, 'msg'=>'User cannot be saved. Please try again later.');
			}
		}
	}
	/*** USERS ***/
	
	/*** AGENTS ***/
	public functions getAgents() {
		$sql = "SELECT * FROM `agents`";
		return $this->db->query($sql)->fetchAll();
	}
	
	public function getAgentByID($agentID) {
		$sql = "SELECT * FROM `agents` WHERE `agent_id`=".$agentID;
		$rsAgent = $this->db->query($sql)->fetch();
		
		$userID = $rsAgent['agent_user_id'];
		$rsUser = $this->getUserByID($userID);
		
		if($rsAgent['agent_parent']!=0) {
			$sql = "SELECT `agent_full_name` FROM `agents` WHERE `agent_id`=".$rsAgent['agent_parent'];
			$rsParent = $this->db->query($sql)->fetch();
			$parentName = $rsParent['agent_full_name'];
		} else {
			$parentName = "";
		}
		$arr = array('agentInfo'=>$rsAgent, 'userInfo'=>$rsUser, 'parent'=>$parentName);
		return $arr;
	}
	
	private function checkIfAgentExists($data) {
		$sql = "SELECT * FROM `agents` WHERE `agent_user_id`=".$data['id'];
		$rsAgent = $this->db->query($sql)->fetch();
		if($rsAgent) {
			return true;
		} else {
			return false;
		}
	}
	
	public function saveAgentInfo($data) {
		if(!$this->checkIfAgentExists($data)) {
			$sql = "INSERT INTO `agents` (`agent_user_id`, `agent_parent`) VALUES (".$data['id'].", ".$data['parentID'].")";
			$this->db->query($sql);
		} 
		$sql = "UPDATE `agents` SET 
				`agent_full_name`='".$data['fullName']."',
				`agent_address`='".$data['address']."',
				`agent_city`='".$data['city']."', 
				`agent_province`='".$data['province']."',
				`agent_postal_code`='".$data['postal']."' 
				WHERE `agent_user_id`=".$data['id'];
		$this->db->query($sql);
	}	
	/*** AGENTS ***/
}

