# [Argon Dashboard 2 PRO](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/default.html?ref=readme-adp) [![Tweet](https://img.shields.io/twitter/url/http/shields.io.svg?style=social&logo=twitter)](https://twitter.com/intent/tweet?url=https://www.creative-tim.com/product/argon-dashboard-pro&text=Check%20Argon%20Dashboard%20Pro%20made%20by%20@CreativeTim%20#webdesign%20#dashboard%20#argondesign%20#html%20https://www.creative-tim.com/product/argon-dashboard-pro)

![version](https://img.shields.io/badge/version-2.0.0-blue.svg) [![GitHub issues open](https://img.shields.io/github/issues/creativetimofficial/ct-argon-dashboard-pro.svg?maxAge=2592000)](https://github.com/creativetimofficial/ct-argon-dashboard-pro/issues?q=is%3Aopen+is%3Aissue) [![GitHub issues closed](https://img.shields.io/github/issues-closed-raw/creativetimofficial/ct-argon-dashboard-pro.svg?maxAge=2592000)](https://github.com/creativetimofficial/ct-argon-dashboard-pro/issues?q=is%3Aissue+is%3Aclosed)

![Image](https://s3.amazonaws.com/creativetim_bucket/products/137/original/argon-dashboard-pro.jpg)

The most complex and innovative Dashboard Made by [Creative Tim](https://creative-tim.com/). Check our latest Premium Bootstrap 5 Dashboard.

Designed for those who like bold elements and beautiful websites. Made of hundred of elements, designed blocks, and fully coded pages, Argon Dashboard 2 PRO is ready to help you create stunning websites and web apps.

We created many examples for pages like Sign In, Profile, and so on. Just choose between a Basic Design, an illustration, or a cover and you are good to go!

**Fully Coded Elements**

Argon Dashboard 2 PRO is built with over 300 frontend individual elements, like buttons, inputs, navbars, nav tabs, cards, or alerts, giving you the freedom of choosing and combining. All components can take variations in color, which you can easily modify using SASS files and classes.

You will save a lot of time going from prototyping to full-functional code because all elements are implemented.  

This Premium Bootstrap 5 Dashboard is coming with prebuilt design blocks, so the development process is seamless,  
switching from our pages to the real website is very easy to be done.

View [all components here](https://www.creative-tim.com/learning-lab/bootstrap/alerts/argon-dashboard).

**Documentation built by Developers**

Each element is well presented in very complex documentation.  

You can read more about the [documentation here](https://www.creative-tim.com/learning-lab/bootstrap/overview/argon-dashboard).

**Example Pages**

If you want to get inspiration or just show something directly to your clients,you can jump-start your development with our pre-built example pages.
You will be able to quickly set up the basic structure for your web project.

View [example pages here](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/default.html).

**HELPFUL LINKS**

-   View [Github Repository](https://github.com/creativetimofficial/ct-argon-dashboard-pro)
-   Check [FAQ Page](https://www.creative-tim.com/faq)

#### Special thanks

During the development of this dashboard, we have used many existing resources from awesome developers. We want to thank them for providing their tools open source:

-   [noUISlider](https://refreshless.com/nouislider/) - JavaScript Range Slider
-   [Popper.js](https://popper.js.org/) - Kickass library used to manage poppers
-   [Flatpickr](https://flatpickr.js.org/) - Useful library used to select date
-   [Choices JS](https://joshuajohnson.co.uk/Choices/) - A nice plugin that select elements with intuitive multiselection and searching but also for managing tags.
-   [CountUp JS](https://inorganik.github.io/countUp.js/) - A dependency-free, lightweight JavaScript class that can be used to quickly create animations that display numerical data in a more interesting way.
-   [Charts Js](https://www.chartjs.org/) - Simple yet flexible JavaScript charting for designers & developers
-   [FullCalendar](https://fullcalendar.io/) - Full-sized drag & drop event calendar
-   [Dropzone](https://www.dropzonejs.com/) - An open source library that provides drag’n’drop file uploads with image previews.
-   [Datatables](https://github.com/fiduswriter/Simple-DataTables) - DataTables but in Vanilla ES2018 JS
-   [jKanban](http://www.riccardotartaglia.it/jkanban/) - Pure agnostic Javascript plugin for Kanban boards
-   [PhotoSwipe](https://photoswipe.com/) - JavaScript image gallery for mobile and desktop, modular, framework independent
-   [Quill](https://quilljs.com/) - A free, open source WYSIWYG editor built for the modern web
-   [Sweet Alerts](https://sweetalert2.github.io/) - A beautiful, responsive, customisable, accessible replacement for Javascript’s popup boxes.
-   [three.js](https://threejs.org/) - JavaScript 3D library
-   [Wizard](https://www.cssscript.com/multi-step-form-bootstrap/) - Animated Multi-step form for Bootstrap

Let us know your thoughts below. And good luck with development!

## Table of Contents

-   [Versions](#versions)
-   [Demo](#demo)
-   [Quick Start](#quick-start)
-   [Documentation](#documentation)
-   [File Structure](#file-structure)
-   [Browser Support](#browser-support)
-   [Resources](#resources)
-   [Reporting Issues](#reporting-issues)
-   [Technical Support or Questions](#technical-support-or-questions)
-   [Licensing](#licensing)
-   [Useful Links](#useful-links)

## Versions



[<img src="https://raw.githubusercontent.com/creativetimofficial/public-assets/master/logos/react-logo.jpg" width="60" height="60"/>](https://www.creative-tim.com/product/argon-dashboard-pro-react)
[<img src="https://github.com/creativetimofficial/public-assets/blob/master/logos/vue-logo.jpg?raw=true" width="60" height="60" />](https://www.creative-tim.com/product/vue-argon-dashboard-pro)
[<img src="https://raw.githubusercontent.com/creativetimofficial/public-assets/master/logos/angular-logo.jpg" width="60" height="60" />](https://www.creative-tim.com/product/argon-dashboard-pro-angular)
[<img src="https://github.com/creativetimofficial/public-assets/blob/master/logos/laravel_logo.png?raw=true" width="60" height="60" />](https://www.creative-tim.com/product/argon-dashboard-pro-laravel)
[<img src="https://raw.githubusercontent.com/creativetimofficial/public-assets/master/logos/nodejs-logo.jpg" width="60" height="60" />](https://www.creative-tim.com/product/argon-dashboard-pro-nodejs)
[<img src="https://raw.githubusercontent.com/creativetimofficial/public-assets/master/logos/nuxt.jpg" width="60" height="60" />](https://www.creative-tim.com/product/nuxt-argon-dashboard-pro)

| React | Vue | Angular |
| --- | --- | --- |
| [![Argon Dashboard PRO React ](https://raw.githubusercontent.com/creativetimofficial/public-assets/master/argon-dashboard-pro-react/argon-dashboard-pro-react.jpg)](https://www.creative-tim.com/product/argon-dashboard-pro-react)  | [![Vue Argon Dashboard PRO](https://raw.githubusercontent.com/creativetimofficial/public-assets/master/vue-argon-dashboard-pro/vue-argon-dashboard-pro.jpg)](https://www.creative-tim.com/product/vue-argon-dashboard-pro) | [![Argon Dashboard PRO Angular](https://raw.githubusercontent.com/creativetimofficial/public-assets/master/argon-dashboard-pro-angular/opt_adp_angular_thumbnail.jpg)](https://www.creative-tim.com/product/argon-dashboard-pro-angular)

| Laravel | NodeJs| Nuxt |
| --- | --- | --- |
| [![Argon Dashboard PRO Laravel ](https://raw.githubusercontent.com/creativetimofficial/public-assets/master/argon-dashboard-pro-laravel/argon-dashboard-pro-laravel.jpg)](https://www.creative-tim.com/product/argon-dashboard-pro-laravel) | [![Argon Dashboard PRO Nodejs](https://s3.amazonaws.com/creativetim_bucket/products/148/thumb/opt_ad_node_thumbnail.jpg?1551367209)](https://www.creative-tim.com/product/argon-dashboard-pro-nodejs) | [![Nuxt Argon Dashboard PRO](https://raw.githubusercontent.com/creativetimofficial/public-assets/master/nuxt-argon-dashboard-pro/opt_adp_nuxt_thumbnail.jpg)](https://www.creative-tim.com/product/nuxt-argon-dashboard-pro)


## Demo

-   [Dashboard](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/default.html?ref=readme-adp)
-   [Automotive](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/automotive.html?ref=readme-adp)
-   [Virtual Reality](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/vr/vr-default.html?ref=readme-adp)
-   [Profile](https://demos.creative-tim.com/argon-dashboard-pro/pages/pages/profile/overview.html?ref=readme-adp)
-   [Account](https://demos.creative-tim.com/argon-dashboard-pro/pages/pages/account/settings.html?ref=readme-adp)
-   [RTL](https://demos.creative-tim.com/argon-dashboard-pro/pages/pages/rtl-page.html?ref=readme-adp)
-   [Applications](https://demos.creative-tim.com/argon-dashboard-pro/pages/applications/kanban.html?ref=readme-adp)
-   [Ecommerce](https://demos.creative-tim.com/argon-dashboard-pro/pages/ecommerce/overview.html?ref=readme-adp)
-   [Sign In](https://demos.creative-tim.com/argon-dashboard-pro/pages/authentication/signin/basic.html?ref=readme-adp)
-   [Sign Up](https://demos.creative-tim.com/test/argon-dashboard-pro/pages/authentication/signup/basic.html?ref=readme-adp)

[View More](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/default.html?ref=readme-adp).

## Quick start

Quick start options:

-   Buy from [Creative Tim](https://www.creative-tim.com/product/argon-dashboard-pro?ref=readme-adp).

## Terminal Commands

1.  Download and Install NodeJs from [NodeJs Official Page](https://nodejs.org/en/download/).
2.  Navigate to the root / directory and run npm install to install our local dependencies.

## Documentation

The documentation for the Argon Dashboard is hosted at our [website](https://www.creative-tim.com/learning-lab/bootstrap/overview/argon-dashboard?ref=readme-adp).

### What's included

Within the download you'll find the following directories and files:

    argon-dashboard-pro
        ├── assets
        │   ├── css
        │   ├── fonts
        │   ├── img
        │   ├── js
        │   │   ├── core
        │   │   ├── plugins
        │   │   └── points.json
        │   │   └── argon-dashboard.min.js
        │   └── scss
        │       ├── argon-dashboard-pro
        │       └── argon-dashboard.scss
        ├── docs
        │   ├── documentation.html
        ├── pages
        │   ├── applications
        │   ├── authentication
        │   ├── dashboards
        │   ├── ecommerce
        │   ├── pages
        ├── CHANGELOG.md
        ├── gulpfile.js
        ├── package.json
        ├── presentation.html

## Browser Support

At present, we officially aim to support the last two versions of the following browsers:

<img src="https://s3.amazonaws.com/creativetim_bucket/github/browser/chrome.png" width="64" height="64"> <img src="https://s3.amazonaws.com/creativetim_bucket/github/browser/firefox.png" width="64" height="64"> <img src="https://s3.amazonaws.com/creativetim_bucket/github/browser/edge.png" width="64" height="64"> <img src="https://s3.amazonaws.com/creativetim_bucket/github/browser/safari.png" width="64" height="64"> <img src="https://s3.amazonaws.com/creativetim_bucket/github/browser/opera.png" width="64" height="64">

## Resources

-   [Live Preview](https://demos.creative-tim.com/argon-dashboard-pro/pages/dashboards/default.html?ref=readme-adp)
-   [Buy Page](https://www.creative-tim.com/product/argon-dashboard-pro?ref=readme-adp)
-   Documentation is [here](https://www.creative-tim.com/learning-lab/bootstrap/overview/argon-dashboard?ref=readme-adp)
-   [License Agreement](https://www.creative-tim.com/license?ref=readme-adp)
-   [Support](https://www.creative-tim.com/contact-us?ref=readme-adp)
-   Issues: [Github Issues Page](https://github.com/creativetimofficial/ct-argon-dashboard-pro/issues)

## Reporting Issues

We use GitHub Issues as the official bug tracker for the Argon Dashboard 2 PRO. Here are some advices for our users that want to report an issue:

1.  Make sure that you are using the latest version of the Argon Dashboard 2 PRO. Check the CHANGELOG from your dashboard on our [website](https://www.creative-tim.com/product/argon-dashboard-pro?ref=readme-adp).
2.  Providing us reproducible steps for the issue will shorten the time it takes for it to be fixed.
3.  Some issues may be browser specific, so specifying in what browser you encountered the issue might help.

## Technical Support or Questions

If you have questions or need help integrating the product please [contact us](https://www.creative-tim.com/contact-us?ref=readme-adp) instead of opening an issue.

## Licensing

-   Copyright 2021 [Creative Tim](https://www.creative-tim.com?ref=readme-adp)
-   Creative Tim [license](https://www.creative-tim.com/license?ref=readme-adp)

## Useful Links

-   [More products](https://www.creative-tim.com/templates?ref=readme-adp) from Creative Tim

-   [Tutorials](https://www.youtube.com/channel/UCVyTG4sCw-rOvB9oHkzZD1w)

-   [Freebies](https://www.creative-tim.com/bootstrap-themes/free?ref=readme-adp) from Creative Tim

-   [Affiliate Program](https://www.creative-tim.com/affiliates/new?ref=readme-adp) (earn money)

-   [Bundles](https://www.creative-tim.com/bundles)

-   [Argon Design](https://www.creative-tim.com/design-system/argon)

-   [Get Discount](https://www.creative-tim.com/coupon)

##### Social Media

Twitter: <https://twitter.com/CreativeTim>

Facebook: <https://www.facebook.com/CreativeTim>

Dribbble: <https://dribbble.com/creativetim>

TikTok: <https://tiktok.com/@creative.tim>

Instagram: <https://instagram.com/creativetimofficial>
